/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (5.1.0).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package com.mobica.BooksService.network.api;

import com.mobica.BooksService.network.model.BookObject;
import com.mobica.BooksService.network.model.BookOutput;
import com.mobica.BooksService.network.model.BooksOutput;
import com.mobica.BooksService.network.model.CreateBookOutput;
import com.mobica.BooksService.network.model.Error;
import com.mobica.BooksService.network.model.Success;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.annotations.ApiIgnore;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2023-03-29T18:36:40.009568300+02:00[Europe/Warsaw]")
@Validated
@Api(value = "books", description = "the books API")
public interface BooksApi {

    default BooksApiDelegate getDelegate() {
        return new BooksApiDelegate() {};
    }

    /**
     * POST /books : Create Book
     * This endpoint creating new book-list and is sending details of book-list with assigned ID 
     *
     * @param body Creating book-list (required)
     * @return Success response for the book-list creation request (status code 201)
     *         or Unexpected error (status code 500)
     */
    @ApiOperation(value = "Create Book", nickname = "createBook", notes = "This endpoint creating new book-list and is sending details of book-list with assigned ID ", response = CreateBookOutput.class, tags={ "book-list", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Success response for the book-list creation request", response = CreateBookOutput.class),
        @ApiResponse(code = 500, message = "Unexpected error", response = Error.class) })
    @PostMapping(
        value = "/books",
        produces = { "application/json" },
        consumes = { "application/json" }
    )
    default ResponseEntity<CreateBookOutput> createBook(@ApiParam(value = "Creating book-list" ,required=true )  @Valid @RequestBody BookObject body) {
        return getDelegate().createBook(body);
    }


    /**
     * DELETE /books/{id} : Delete Book by ID
     * This endpoint is deleting book-list 
     *
     * @param id The ID of an book-list (required)
     * @return Default Success response (status code 202)
     *         or Not Found (status code 404)
     *         or Unexpected error (status code 500)
     */
    @ApiOperation(value = "Delete Book by ID", nickname = "deleteBookById", notes = "This endpoint is deleting book-list ", response = Success.class, tags={ "book-list", })
    @ApiResponses(value = { 
        @ApiResponse(code = 202, message = "Default Success response", response = Success.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Unexpected error", response = Error.class) })
    @DeleteMapping(
        value = "/books/{id}",
        produces = { "application/json" }
    )
    default ResponseEntity<Success> deleteBookById(@ApiParam(value = "The ID of an book-list",required=true) @PathVariable("id") Integer id) {
        return getDelegate().deleteBookById(id);
    }


    /**
     * GET /books/{id} : Get Book by ID
     * This endpoint is sending details of book-list chosen by ID 
     *
     * @param id The ID of an book-list (required)
     * @return Success response for the book-list request (status code 200)
     *         or Not Found (status code 404)
     *         or Unexpected error (status code 500)
     */
    @ApiOperation(value = "Get Book by ID", nickname = "getBookById", notes = "This endpoint is sending details of book-list chosen by ID ", response = BookOutput.class,  tags={ "book-list", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success response for the book-list request", response = BookOutput.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Unexpected error", response = Error.class) })
    @GetMapping(
        value = "/books/{id}",
        produces = { "application/json" }
    )
    default ResponseEntity<BookOutput> getBookById(@ApiParam(value = "The ID of an book-list",required=true) @PathVariable("id") Integer id) {
        return getDelegate().getBookById(id);
    }


    /**
     * GET /books : Get Books
     * This endpoint is sending details of all book-lists 
     *
     * @param skip how many records to skip (optional, default to 0)
     * @param limit how many records to return (optional, default to 10)
     * @return Success response for the book-lists request (status code 200)
     *         or Unexpected error (status code 500)
     */
    @ApiOperation(value = "Get Books", nickname = "getBooks", notes = "This endpoint is sending details of all book-lists ", response = BooksOutput.class, tags={ "book-list", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success response for the book-lists request", response = BooksOutput.class),
        @ApiResponse(code = 500, message = "Unexpected error", response = Error.class) })
    @GetMapping(
        value = "/books",
        produces = { "application/json" }
    )
    default ResponseEntity<BooksOutput> getBooks(@Min(0L)@ApiParam(value = "how many records to skip", defaultValue = "0") @Valid @RequestParam(value = "skip", required = false, defaultValue="0") Long skip,@Min(1L)@ApiParam(value = "how many records to return", defaultValue = "10") @Valid @RequestParam(value = "limit", required = false, defaultValue="10") Long limit) {
        return getDelegate().getBooks(skip, limit);
    }


    /**
     * PUT /books/{id} : Put Book by ID
     * This endpoint is updating book-list 
     *
     * @param id The ID of an book-list (required)
     * @param body Updating book-list (required)
     * @return Success response for the book-list request (status code 202)
     *         or Not Found (status code 404)
     *         or Unexpected error (status code 500)
     */
    @ApiOperation(value = "Put Book by ID", nickname = "putBookById", notes = "This endpoint is updating book-list ", response = BookOutput.class, tags={ "book-list", })
    @ApiResponses(value = { 
        @ApiResponse(code = 202, message = "Success response for the book-list request", response = BookOutput.class),
        @ApiResponse(code = 404, message = "Not Found", response = Error.class),
        @ApiResponse(code = 500, message = "Unexpected error", response = Error.class) })
    @PutMapping(
        value = "/books/{id}",
        produces = { "application/json" },
        consumes = { "application/json" }
    )
    default ResponseEntity<BookOutput> putBookById(@ApiParam(value = "The ID of an book-list",required=true) @PathVariable("id") Integer id,@ApiParam(value = "Updating book-list" ,required=true )  @Valid @RequestBody BookObject body) {
        return getDelegate().putBookById(id, body);
    }

}
